#include <ruby.h>

void init_linear_algebra(VALUE);
void init_eigenvalue_eigenvector(VALUE);
void init_nonlinear_equations(VALUE);
void init_extrema(VALUE);
void init_interpolation_approximation(VALUE);
void init_transforms(VALUE);
void init_numerical_differentiation_quadrature(VALUE);
void init_differential_equations(VALUE);
void init_special_functions(VALUE);
void init_pseudorandom(VALUE);

static VALUE
rb_with_narray(self)
     VALUE self;
{
#ifdef HAVE_NARRAY_H
  return Qtrue;
#else
  return Qfalse;
#endif
}

void Init_ssl2()
{

  VALUE mSSL2;

#ifdef HAVE_NARRAY_H
  rb_require("narray");
#endif

  mSSL2 = rb_define_module("SSL2");

  rb_define_module_function(mSSL2, "with_narray?", rb_with_narray, 0);

  init_linear_algebra(mSSL2);
  init_eigenvalue_eigenvector(mSSL2);
  init_nonlinear_equations(mSSL2);
  init_extrema(mSSL2);
  init_interpolation_approximation(mSSL2);
  init_transforms(mSSL2);
  init_numerical_differentiation_quadrature(mSSL2);
  init_differential_equaions(mSSL2);
  init_special_function(mSSL2);
  init_pseudorandom(mSSL2);
}
